// 输入搜索引擎关键词
function inputSearchWords(tab, word, andEnter, wordTime)
{
	//alert(word);
	setTimeout(function()
	{
		// 找到合适的标签页
		if(tab==null)
			return;
		var doc	= tab.linkedBrowser.contentDocument;
		
		
		var inputs		= doc.getElementsByTagName('input');
		var assignval	= false;	// 是否直接赋值
		
		// 找到对应的输入框
		var input	= null;
		for(var i=0; i<inputs.length; i++)
		{
			if		(doc.location.host=='www.soso.com' && inputs[i].id=='s_input')
			{
				input		= inputs[i];
				assignval	= true;
				break;
			}
			else if(doc.location.host=='www.baidu.com' && inputs[i].id=='kw')
			{
				input		= inputs[i];
				assignval	= false;
				break;
			}
			else if(doc.location.host=='www.google.com.hk' && inputs[i].id=='lst-ib')
			{
				input		= inputs[i];
				assignval	= true;
				break;
			}
			else if(doc.location.host=='www.hao123.com' && inputs[i].class=='js_word' && inputs[i].name=='word')
			{
				input	= inputs[i];
				break;
			}
		}
		
		if(input==null)
			return;
		
		// 光标移动到末尾
		
		// 输入文字
		input.focus();
		if(assignval==false)	// 不可直接赋值的
		{
			for(var i=0; i<word.length; i++)
			{
				var charCodeArg	= word.charCodeAt(i);
				var evt = doc.createEvent('KeyEvents');
				evt.initKeyEvent('keydown', true, true, doc.defaultView, false,false,false,false, 0, charCodeArg);
			    input.dispatchEvent(evt);
			    
			    var evt2 = doc.createEvent('KeyEvents');
				evt2.initKeyEvent('keypress', true, true, doc.defaultView, false,false,false,false, 0, charCodeArg);
				input.dispatchEvent(evt2);
			}
		}
		else
		{
			input.value	= input.value + '' + word;
		}
		
		// 按回车
		if(andEnter==true)
		{
			var evt = doc.createEvent('KeyEvents');
			evt.initKeyEvent('keydown', true, true, doc.defaultView, false,false,false,false, 13, 13);
		    input.dispatchEvent(evt);
		    
		    var evt2 = doc.createEvent('KeyEvents');
			evt2.initKeyEvent('keypress', true, true, doc.defaultView, false,false,false,false, 13, 13);
			input.dispatchEvent(evt2);
		}
	}, wordTime);
	//alert(input.id);
};

// 翻页并打开包含自己关键词的页面
function turnAndOpenPage(tab, wordTime)	// idx参数，为打开页面序号数
{
	setTimeout(function()
	{
		// 找到合适的标签页
		if(tab==null)
			return;
		
		var doc	= tab.linkedBrowser.contentDocument;
		var glb	= ptOnlineTask[tab.ptSiteID];
		glb.searchPage ++;
		
		// 遍历所有的a链接
		//var str			= '';
		var titMatched	= [];	// 标题所匹配的
		var turnPage	= -1;	// 翻页的
		var links		= doc.getElementsByTagName('a');
		for (var i=0; i<links.length; i++)
		{
			links[i].target	= '_top';
			for(var j=0; j<glb.banTit.length; j++)
			{
				if(links[i].text.indexOf(glb.banTit[j])>=0)	// 标题匹配
				{
					titMatched.push(i);
				}
			}

			if(links[i].href.indexOf(doc.location.host)>0)	// 搜索引擎内部链接包含数字串(翻页链接)
			{
				if(links[i].text.match(/^\d+$/))
				{
					if(parseInt(links[i].text) == glb.searchPage)
					turnPage	= i;
					//alert(links[i].text);
				}
			}
		}
		
		if(titMatched.length>0)	// 存在正确的标题匹配
		{
			//alert(var_dump_ergodic(titMatched) );
			var idx	= titMatched[parseInt(getRandom(0, titMatched.length-1))];
			links[idx].click();
			return;
		}
		
		if(turnPage>-1)
		{
			links[turnPage].click();	// 点击下一个数字页面
		}

		
	}, wordTime);
};


// 操作搜索引擎
function operateSearchEngine(tab)
{
	// 找到合适的标签页
	if(!tab || !tab.ptSiteID)
		return;
	
	var glb			= ptOnlineTask[tab.ptSiteID];
	//f_logs('wew.txt', var_dump(glb));
	var wordTime	= 0;
	if(!tab.ptSeoEvent)
	{
		tab.ptSeoEvent	= 1;
		glb.searchPage	= 1;
		
		// 输入关键词
		inputSearchWords(tab, glb.keywords, true, wordTime);	// 输入搜索的关键词
		wordTime		+= Math.round(getRandom(2000, 3600));
		
		
		// 翻页，并打开页面中属于自己的页面
		for(var j=0; j<glb.pv; j++)
		{
			turnAndOpenPage(tab, wordTime);	// 翻页并打开包含自己关键词的页面
			wordTime	   += Math.round(getRandom(4000, 6000));
		}
	}
};