﻿// 常量
var ptVer			= '';																	// 版本号
var ptLanguage		= 0;																	// 默认语言
var ptDiskSerial	= '';																	// 磁盘序列号
var ptMaxTabs		= 5;																	// 同时打开的最大标签页
var ptOnlineTask	= [];																	// 正在浏览器打开着的任务
var	ptIsIdLogin		= false;																// 是用户id登录?
var ptTaskCount		= 0;																	// 客户端任务计数
var ptPageCount		= 0;																	// 客户端页面计数
var ptLastStat		= 0;																	// 客户端任务/页面数最后一次的改动时间，用来检测是否因为对话框等假死
var ptAgent			= '';																	// 从客户端获取到的浏览器标示
var ptAcceptLan		= '';																	// 从客户端获取到的浏接受语言
var ptTrayTitle		= '';																	// 系统托盘提示
var ptUserID		= 0;																	// 用户ID
var ptPID			= 0;																	// 进程ID
var ptJsonTask		= [];																	// 下载到的任务保存在这里
var ptPreSubmit		= [];																	// 将提交的任务结果（包含innerHTML长度和childElementCount）
var ptLoginSucceed	= false;																// 是否验证登录成功
var ptIsSardineAgent= false;																// 浏览器表示头是否为火狐
var ptIllicitSuffix	= ['.exe', '.dll', '.txt', '.rar', '.zip', '.gz', '.tar', '.rpm', '.apk'];	// 无效的网址后缀
var ptIllicitPrefix	= ['mailto:'];																// 无效的网址前缀
var ptJsDll			= null;
var ptJsDllPath		= '';																		// 调用tray.dll的路径
var ptJsDataPath	= '';																		// 保存下载的临时数据（只有路径，无文件名）
var ptBMD			= [];																		// 域名白名单
var ptHMD			= [];																		// 域名黑名单
var	  ptBrowserPath	= '';
const ptExtendSuffix= '\\chrome\\pt\\';																	// 扩展所在目录
const ptSysName		= 'Pt promotion site traffic tools';


//类似MessageBox prompts.alert(null, 'aaaa', 'dddd');
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
Components.utils.import("resource://gre/modules/FileUtils.jsm");
Components.utils.import("resource://gre/modules/AddonManager.jsm");
Components.utils.import("resource://gre/modules/Services.jsm");
Components.utils.import("resource://gre/modules/ctypes.jsm");	// 调用自写DLL必须
var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
// 初始化读写内部参数
var prefservice = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
//const require = Cu.import("resource://gre/modules/devtools/Loader.jsm", {}).devtools.require;
// 初始化弹窗规则
var	popprefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('capability.policy.');
popprefs.setCharPref('policynames', 'AllowedjsPopupSites'); 
popprefs.setCharPref('default.Window.open', 'noAccess');
popprefs.setCharPref('AllowedjsPopupSites.Window.open', 'allAccess');
popprefs.setCharPref('AllowedjsPopupSites.sites', '');


function setAgentAndLanguage(json)	// 设置浏览器标示和语言
{
	var lan		= acceptlan2lan(json.acceptLan);
	setStrPref(	'general.useragent.override', json.agent);
	setStrPref(	'intl.accept_languages', json.acceptLan);
	setStrPref(	'font.language.group', lan);
	setStrPref(	'general.useragent.locale', lan);
	ptAgent			= json.agent;
	ptAcceptLan		= json.acceptLan;
	ptIsSardineAgent= (json.agent.indexOf('MSIE')>0) ? false : true;// 判断浏览器类型
}

function ptAddPreSubmit(sid, url, size, child)	// 追加数据到ptPreSubmit
{
	 for (var i in ptPreSubmit)
	 {
		 if(ptPreSubmit[i].sid==sid)
			 return;
	 }
	 ptPreSubmit.push({'sid': sid, 'url': url, 'size': size, 'child': child});
}

function timeStamp()
{
	var myDate = new Date();
	return Math.round(myDate.getTime()/1000);
}


function commStatus(status)	// 输出运行状态
{
	document.getElementById('ptCommonMsg').textContent = status;
}

function taskStatus(status)	// 任务状态
{
	document.getElementById('ptTaskMsg').textContent = status;
}

function updateTaskStatus(task, page)	// 更新账户状态
{
	ptTaskCount	= ptTaskCount + task;
	ptPageCount	= ptPageCount + page;
	ptLastStat	= Date.now();
	
	var str	= {
		'taskCount'	: ptTaskCount,
		'pageCount'	: ptPageCount,
		'timeMark'	: parseInt(Date.now()/1000)
	};
	
	var talkData = JSON.stringify(str);
	writeMemoryTalk(talkData);
}


function removeHTMLTag(str)
{
	str = str.replace(/<.*?>/g, ''); //去除HTML tag
	str = str.replace(/[\s\r\n]/g, ''); //去除多余空行
	str=str.replace(/&nbsp;/ig, '');//去掉&nbsp;
	return str;
}

function stripos(f_haystack, f_needle, f_offset)
{
	  // http://kevin.vanzonneveld.net
	  // +     original by: Martijn Wieringa
	  // +      revised by: Onno Marsman
	  // *         example 1: stripos('ABC', 'a');
	  // *         returns 1: 0
	  var haystack = (f_haystack + '').toLowerCase();
	  var needle = (f_needle + '').toLowerCase();
	  var index = 0;

	  if ((index = haystack.indexOf(needle, f_offset)) !== -1) {
	    return index;
	  }
	  return false;
};

function acceptlan2lan(str)	// 从浏览器接受的语言中，获取浏览器语言类型
{
	if(stripos(str, 'en-US')>=0)	return 'en-US';
	if(stripos(str, 'zh-TW')>=0)	return 'zh-TW';
	if(stripos(str, 'ja')>=0)		return 'ja';
//	if(stripos(str, 'zh-cn')>=0)	return 'zh-CN';
	return 'zh-CN';
};

String.prototype.trim = function()	// 添加trim函数
{
	return this.replace(/(^\s*)|(\s*$)/g, ''); 
};

function applyPopup(url, ratio)		// 应用弹窗规则, ratio比率
{
	if(Math.random() < ratio/100)
	{
		var new_sites	= popprefs.getCharPref('AllowedjsPopupSites.sites') + ' ' + url;
		popprefs.setCharPref('AllowedjsPopupSites.sites', new_sites.trim());
	}
};

function migratingMigrate()			// 从别的浏览器迁移数据
{
	/*	flags 见：c:/src/browser/components/migration/public/nsIBrowserProfileMigrator.idl
		const unsigned short ALL         = 0x0000;
		const unsigned short SETTINGS    = 0x0001;
		const unsigned short COOKIES     = 0x0002;
		const unsigned short HISTORY     = 0x0004;
		const unsigned short FORMDATA    = 0x0008;
		const unsigned short PASSWORDS   = 0x0010;
		const unsigned short BOOKMARKS   = 0x0020;
		const unsigned short OTHERDATA   = 0x0040;
		
		浏览器类型：browser/migration/migration.xul
		可选:  phoenix / ie / seamonkey / dogbert / opera / fromfile / nothing
	 */
	
	var flags	= 16 + 8 + 2;
	var kIMig = Components.interfaces.nsIBrowserProfileMigrator;
	var contractID	= '@mozilla.org/profile/migrator;1?app=browser&type=' + 'ie';
	var _migrator	= Components.classes[contractID].createInstance(kIMig);
	_migrator.migrate(flags, null, null);
};

function var_dump(val)
{
	var ret = '';
	if		(val === null)					ret = 'NULL';
    else if (typeof val === 'boolean')		ret = 'bool(' + val + ')';
    else if (typeof val === 'string')		ret = 'string(' + val.length + ') "' + val + '"';
    else if (typeof val === 'number')
    {
    	if (parseFloat(val) == parseInt(val, 10))
    		ret = 'int(' + val + ')';
    	else
    		ret = 'float(' + val + ')';
    }
    else if (typeof val === 'undefined')	ret = 'undefined';
    else if (typeof val === 'function')
    {
    	var funcLines = val.toString().split('\n');
    	ret = '';
    	for (var i = 0, fll = funcLines.length; i < fll; i++)
    	{
    		ret += (i !== 0 ? '\n' + thick_pad : '') + funcLines[i];
    	}
    }
    else if (val instanceof Date)			ret = 'Date(' + val + ')';
    else if (val instanceof RegExp)			ret = 'RegExp(' + val + ')';
    else if (val.nodeName)
    {
    	switch (val.nodeType)
    	{
    		case 1:
    			if (typeof val.namespaceURI === 'undefined' || val.namespaceURI === 'http://www.w3.org/1999/xhtml')	// Undefined namespace could be plain XML, but namespaceURI not widely supported
    				ret = 'HTMLElement("' + val.nodeName + '")';
    			else
    			{
    				ret = '\r\nXML Element("' + val.nodeName + '")\r\n-----------------------------------------------------------------------------------\r\n';
    			}
    			break;
    		case 2:
    			ret = 'ATTRIBUTE_NODE(' + val.nodeName + ')';
    			break;
    		case 3:
    			ret = 'TEXT_NODE(' + val.nodeValue + ')';
    			break;
    		case 4:
    			ret = 'CDATA_SECTION_NODE(' + val.nodeValue + ')';
    			break;
    		case 5:
    			ret = 'ENTITY_REFERENCE_NODE';
    			break;
    		case 6:
    			ret = 'ENTITY_NODE';
    			break;
    		case 7:
    			ret = 'PROCESSING_INSTRUCTION_NODE(' + val.nodeName + ':' + val.nodeValue + ')';
    			break;
    		case 8:
    			ret = 'COMMENT_NODE(' + val.nodeValue + ')';
    			break;
    		case 9:
    			ret = 'DOCUMENT_NODE';
    			break;
    		case 10:
    			ret = 'DOCUMENT_TYPE_NODE';
    			break;
    		case 11:
    			ret = 'DOCUMENT_FRAGMENT_NODE';
    			break;
    		case 12:
    			ret = 'NOTATION_NODE';
    			break;
    	}
    }
	for(key in val)
	{
		var sub_type	= (key!='accessibleType') ? typeof(val[key]) : '';
		if(sub_type!='' && sub_type!='object' && sub_type!='function')
			ret	+= key + "\t=> " + val[key] + "\r\n";
		else
			ret	+= key + "\t=> " + sub_type + "{}\r\n";
	}
    return ret;
};

function var_dump_ergodic()	// 遍历方式查看变量
{
	var output = '',
		pad_char = "\t",
		pad_val = 1,
		lgth = 0,
		i = 0;
	var _getFuncName = function (fn)
	{
		var name = (/\W*function\s+([\w\$]+)\s*\(/).exec(fn);
		if (!name)
		{
			return '(Anonymous)';
		}
		return name[1];
	};

	var _repeat_char = function (len, pad_char)
	{
		var str = '';
		for (var i = 0; i < len; i++)
		{
			str += pad_char;
		}
		return str;
	};
	var _getInnerVal = function (val, thick_pad)
	{
		var ret = '';
		if (val === null)
		{
			ret = 'NULL';
		}
		else if (typeof val === 'boolean')
		{
			ret = 'bool(' + val + ')';
		}
		else if (typeof val === 'string')
		{
			ret = 'string(' + val.length + ') "' + val + '"';
		}
		else if (typeof val === 'number')
		{
			if (parseFloat(val) == parseInt(val, 10))
			{
				ret = 'int(' + val + ')';
			}
			else
			{
				ret = 'float(' + val + ')';
			}
		}
		// The remaining are not PHP behavior because these values only exist in this exact form in JavaScript
		else if (typeof val === 'undefined')
		{
			ret = 'undefined';
		}
		else if (typeof val === 'function')
		{
			var funcLines = val.toString().split('\r\n');
			ret = '';
			for (var i = 0, fll = funcLines.length; i < fll; i++)
			{
				ret += (i !== 0 ? '\r\n' + thick_pad : '') + funcLines[i];
			}
		}
		else if (val instanceof Date)
		{
			ret = 'Date(' + val + ')';
		}
		else if (val instanceof RegExp)
		{
			ret = 'RegExp(' + val + ')';
		}
		else if (val.nodeName)
		{ // Different than PHP's DOMElement
			switch (val.nodeType)
			{
				case 1:
					if (typeof val.namespaceURI === 'undefined' || val.namespaceURI === 'http://www.w3.org/1999/xhtml')
					{ // Undefined namespace could be plain XML, but namespaceURI not widely supported
						ret = 'HTMLElement("' + val.nodeName + '")';
					}
					else
					{
						ret = 'XML Element("' + val.nodeName + '")';
					}
					break;
				case 2:
					ret = 'ATTRIBUTE_NODE(' + val.nodeName + ')';
					break;
				case 3:
					ret = 'TEXT_NODE(' + val.nodeValue + ')';
					break;
				case 4:
					ret = 'CDATA_SECTION_NODE(' + val.nodeValue + ')';
					break;
				case 5:
					ret = 'ENTITY_REFERENCE_NODE';
					break;
				case 6:
					ret = 'ENTITY_NODE';
					break;
				case 7:
					ret = 'PROCESSING_INSTRUCTION_NODE(' + val.nodeName + ':' + val.nodeValue + ')';
					break;
				case 8:
					ret = 'COMMENT_NODE(' + val.nodeValue + ')';
					break;
				case 9:
					ret = 'DOCUMENT_NODE';
					break;
				case 10:
					ret = 'DOCUMENT_TYPE_NODE';
					break;
				case 11:
					ret = 'DOCUMENT_FRAGMENT_NODE';
					break;
				case 12:
					ret = 'NOTATION_NODE';
					break;
			}
		}
		return ret;
	};

	var _formatArray = function (obj, cur_depth, pad_val, pad_char)
	{
		var someProp = '';
		if (cur_depth > 0)
		{
			cur_depth++;
		}

		var base_pad = _repeat_char(pad_val * (cur_depth - 1), pad_char);
		var thick_pad = _repeat_char(pad_val * (cur_depth + 1), pad_char);
		var str = '';
		var val = '';

		if (typeof obj === 'object' && obj !== null)
		{
			if (obj.constructor && _getFuncName(obj.constructor) === 'PHPJS_Resource')
			{
				return obj.var_dump();
			}
			lgth = 0;
			for (someProp in obj)
			{
				lgth++;
			}
			str += 'array(' + lgth + ') {\r\n';
			for (var key in obj)
			{
				var objVal = obj[key];
				if (typeof objVal === 'object' && objVal !== null && !(objVal instanceof Date) && !(objVal instanceof RegExp) && !objVal.nodeName)
				{
					str += thick_pad + '[' + key + '] =>\t' + _formatArray(objVal, cur_depth + 1, pad_val, pad_char);
				}
				else
				{
					val = _getInnerVal(objVal, thick_pad);
					str += thick_pad + '[' + key + '] =>\t' + val + '\r\n';
				}
			}
			str += base_pad + '}\r\n';
		}
		else
		{
			str = _getInnerVal(obj, thick_pad);
		}
		return str;
	};

	output = _formatArray(arguments[0], 0, pad_val, pad_char);
	for (i = 1; i < arguments.length; i++)
	{
		output += '\r\n' + _formatArray(arguments[i], 0, pad_val, pad_char);
	}

	return output;
};


function in_array(needle, haystack)
{
	for(var i=0; i<haystack.length; i++)
	{
		if (haystack[i] == needle)
			return true;
	}
	return false;
};

function getRootDomain(domain)	// 获得根域名
{
	var bak		= domain;
	// 互联网名称与数字地址分配机构  http://www.iana.org/domains/root/db
	var IANA	= ['ac', 'ad', 'ae', 'aero', 'af', 'ag', 'ai', 'al', 'am', 'an', 'ao', 'aq', 'ar', 'arpa', 'as', 'asia', 'at', 'au', 'aw', 'ax', 'az', 'ba', 'bb', 'bd', 'be', 
			'bf', 'bg', 'bh', 'bi', 'biz', 'bj', 'bl', 'bm', 'bn', 'bo', 'bq', 'br', 'bs', 'bt', 'bv', 'bw', 'by', 'bz', 'ca', 'cat', 'cc', 'cd', 'cf', 'cg', 'ch', 'ci', 'ck', 'cl', 
			'cm', 'cn', 'co', 'com', 'coop', 'cr', 'cu', 'cv', 'cw', 'cx', 'cy', 'cz', 'de', 'dj', 'dk', 'dm', 'do', 'dz', 'ec', 'edu', 'ee', 'eg', 'eh', 'er', 'es', 'et', 'eu', 'fi', 
			'fj', 'fk', 'fm', 'fo', 'fr', 'ga', 'gb', 'gd', 'ge', 'gf', 'gg', 'gh', 'gi', 'gl', 'gm', 'gn', 'gov', 'gp', 'gq', 'gr', 'gs', 'gt', 'gu', 'gw', 'gy', 'hk', 'hm', 'hn', 
			'hr', 'ht', 'hu', 'id', 'ie', 'il', 'im', 'in', 'info', 'int', 'io', 'iq', 'ir', 'is', 'it', 'je', 'jm', 'jo', 'jobs', 'jp', 'ke', 'kg', 'kh', 'ki', 'km', 'kn', 'kp', 
			'kr', 'kw', 'ky', 'kz', 'la', 'lb', 'lc', 'li', 'lk', 'lr', 'ls', 'lt', 'lu', 'lv', 'ly', 'ma', 'mc', 'md', 'me', 'mf', 'mg', 'mh', 'mil', 'mk', 'ml', 'mm', 'mn', 'mo', 
			'mobi', 'mp', 'mq', 'mr', 'ms', 'mt', 'mu', 'museum', 'mv', 'mw', 'mx', 'my', 'mz', 'na', 'name', 'nc', 'ne', 'net', 'nf', 'ng', 'ni', 'nl', 'no', 'np', 'nr', 'nu', 'nz', 
			'om', 'org', 'pa', 'pe', 'pf', 'pg', 'ph', 'pk', 'pl', 'pm', 'pn', 'post', 'pr', 'pro', 'ps', 'pt', 'pw', 'py', 'qa', 're', 'ro', 'rs', 'ru', 'rw', 'sa', 'sb', 'sc', 
			'sd', 'se', 'sg', 'sh', 'si', 'sj', 'sk', 'sl', 'sm', 'sn', 'so', 'sr', 'ss', 'st', 'su', 'sv', 'sx', 'sy', 'sz', 'tc', 'td', 'tel', 'tf', 'tg', 'th', 'tj', 'tk', 'tl', 
			'tm', 'tn', 'to', 'tp', 'tr', 'travel', 'tt', 'tv', 'tw', 'tz', 'ua', 'ug', 'uk', 'um', 'us', 'uy', 'uz', 'va', 'vc', 've', 'vg', 'vi', 'vn', 'vu', 'wf', 'ws', 'xxx', 
			'ye', 'yt', 'za', 'zm', 'zw',  '测试', 'परीक्षा', '한국', 'ভারত', 'বাংলা', 'испытание', 'қаз', 'срб', '테스트', 'சிங்கப்பூர்', 'טעסט', '中国', '中國', 'భారత్', 'ලංකා', '測試', 'ભારત', 
			'भारत', 'آزمایشی', 'பரிட்சை', 'укр', '香港', 'δοκιμή', 'إختبار', '台湾', '台灣', 'мон', 'الجزائر', 'عمان',
			'ایران', 'امارات', 'پاکستان', 'الاردن', 'بھارت', 'المغرب', 'السعودية', 'سودان', 'مليسيا', 'გე', 'ไทย', 'سورية', 'рф', 'تونس', 'ਭਾਰਤ', 'مصر', 'قطر', 'இலங்கை', 'இந்தியா', 
			'新加坡', 'فلسطين', 'テスト'];
	// 去掉域名后缀
	var suff_pos	= 0;
	for(var i=1; i>0; i++)
	{
		var is_find	= false;
		for(var j=0; j<IANA.length; j++)
		{
			var root_pos	= domain.length - IANA[j].length -1;
			var lastchr		= domain.substr(root_pos);
			if( lastchr == ('.' + IANA[j]) )
			{
				domain		= domain.substr(0, root_pos);
				suff_pos	= root_pos;
				is_find		= true;
				break;
			}
		}
		if(is_find==false)
		{
			i= -100;
			break;	
		}
	}

	//	alert(domain);
	var dot	= domain.lastIndexOf('.');
	if( dot > 0 )
	{
		var re	= /^\d+\.\d+\.\d+\.\d+$/;
		if(re.test(domain)==true)
			return domain;
		bak	= bak.substr( dot + 1 );
	}
	return bak;
};

function getDomain(url)			// 获得域名
{
	if( url.length==0 )
		return '';
	var a1	= url.indexOf('://');
	if(a1>=0)
		url	= url.substring(a1+3);
	else
		return '';

	var a2	= url.indexOf(':');
	if	( a2>0 )
		url	= url.substr(0, a2);
	
	a2	= url.indexOf('/');
	if	( a2>0 )
		url	= url.substr(0, a2);

	return getRootDomain(url);
};

function getRandom(min, max)	// 随机数函数
{
	return min + Math.random() * (max - min);
};

function getDomainUrls(doc, domain)		// 获取dom树种的所有网址，第二个参数url，实际为新窗口之来路
{
	var matchs	= [];
	var urls	= doc.getElementsByTagName('a');
	for (var i=0; i<urls.length; i++)
	{
		var is_ok	= true;
		// 屏蔽非法后缀
		for(var j=0; j<illicitUrlSuffix.length; j++)
		{
			var cell_len	= illicitUrlSuffix[j].length;
			var cell_url	= urls[i].href.substr(urls[i].href.length - cell_len, cell_len);
			if( cell_url.toLowerCase() == illicitUrlSuffix[j].toLowerCase() )
			{
				is_ok	= false;
				break;
			}
		}
		if(is_ok == true && getDomain( urls[i].href )==domain)
			matchs.push( urls[i].href );
	}
	return matchs;
};

function url4Regex( str )				// 正则表达式处理URL，处理[1-300]这种
{
	//var patt1 = new RegExp(/\[\d+-\d+\]/);
	var	url		= str.toString();
	var reg		= /\[(\d+)-(\d+)\]/;
	var matched	= url.match(reg);
	while(matched)
	{
		var dist	= Math.round(getRandom(parseInt(matched[1]), parseInt(matched[2])));
		url			= url.replace(matched[0], dist);
		matched		= url.match(reg);
	}
	return url;
};

function restoreUrl(str)			// 将json中， x|www.baidu.com格式的网址复原
{
	var ret		= '';
	var start	= str.indexOf('$');
	if(start>0)
	{
		var protocol	= str.substr(0, start);
		var body		= url4Regex( str.substr(start+1) );
		ret	= networkProtocol[protocol] + '://' + body;
	}
	return ret;
};

function getSection(str, i)	// 将json中，如xx|yy|zz参数，取第0段，第1段，第2段
{
	var str_arr	= str.split('$');
	return str_arr[i];
};

function fillZero(num)		// 数字字符串左边补0
{
	if(num>9)
		return num;
	else
		return '0' + num;
};

function f_logs(fName, body)	// 强制记录日志
{
	var unixtime	= new Date().getTime();
	var dateObj		= new Date();
	var lTime		= dateObj.getFullYear();				// 函数 -- 返回四位数年份
	lTime += '-' + fillZero( dateObj.getMonth()	);			// 函数 -- 返回月份数(0-11)
	lTime += '-' + fillZero( dateObj.getDate()	);			// 函数 -- 返回天数(1-31)
	lTime += ' ' + fillZero( dateObj.getHours()	);			// 函数 -- 返回小时数(0-23)
	lTime += ':' + fillZero( dateObj.getMinutes()	);		// 函数 -- 返回分钟数(0-59)
	lTime += ':' + fillZero( dateObj.getSeconds()	);		// 函数 -- 返回的秒数(0-59)
	
	var file	= Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('DefRt', Components.interfaces.nsIFile);
	file.append(fName);

	/*
	PR_RDONLY 		0x01 	Open for reading only.
	PR_WRONLY 		0x02 	Open for writing only.
	PR_RDWR 		0x04 	Open for reading and writing.
	PR_CREATE_FILE 	0x08 	If the file does not exist, the file is created. If the file exists, this flag has no effect.
	PR_APPEND 		0x10 	The file pointer is set to the end of the file prior to each write.
	PR_TRUNCATE 	0x20 	If the file exists, its length is truncated to 0.
	PR_SYNC 		0x40 	If set, each write will wait for both the file data and file status to be physically updated.
	PR_EXCL 		0x80 	With PR_CREATE_FILE, if the file does not exist, the file is created. If the file already exists, no action and NULL is returned.
	*/
	var strm 	= Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
	strm.QueryInterface(Components.interfaces.nsIOutputStream);
	strm.QueryInterface(Components.interfaces.nsISeekableStream);

	body = lTime + ' ( ' + unixtime + ' ):' + "\t" + body + "\r\n\r\n";
	strm.init( file, 0x04 | 0x08 | 0x10, 420, 0 );	// 追加写
	//strm.init( file, 0x08 | 0x04 | 0x20, 420, 0 );	// 存在则清空
	strm.write(body, body.length );
	strm.flush();
	strm.close();
};

function logs(fName, body)		// debug==true时记录日志
{
	if(debug==false)
		return;
	f_logs(fName, body);
};

function delTab(tab)	// 删除标签页
{
	//tab.stop();
	gBrowser.removeTab( tab );
};

function initObjPosition(obj)	// 初始化对象坐标
{
	obj._top		= 0;
	obj._right		= 0;
	obj._bottom		= 0;
	obj._left		= 0;
};

var classUrlTree	= function()	// url树
{
	var _parameter			= new Object();
	_parameter.siteid		= 0;
	_parameter.click2		= 0;
	_parameter.url			= '';
	_parameter.tablink		= '';
	_parameter.node			= [];
	return _parameter;
};

function setCookie(doc, cname, cvalue, exMin)	// 到期的分钟数（真实推广专用）
{
	var d = new Date();
	d.setTime(d.getTime()+(exMin*60*60*1000));
	var expires = 'expires=' + d.toGMTString();
	doc.cookie = cname + "=" + cvalue + "; " + expires;
};

function getCookie(doc, cname) // （真实推广专用）
{
	var name = cname + '=';
	var ca = doc.cookie.split(';');
	for(var i=0; i<ca.length; i++) 
	{
		var c = ca[i].trim();
		if (c.indexOf(name)==0) return c.substring(name.length,c.length);
	}
	return '';
};

function ptTGOpenUrl(url, rfr)		// 在标签页中打开网址（真实推广专用）
{
	var proceeid	= null;
	if (rfr.length>0)	// 存在来路
	{
		var ios		= Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var referer	= ios.newURI(rfr, null, null);
		gBrowser.loadOneTab(url, referer, null, null, true, false);
	}
	else
		gBrowser.loadOneTab(url, null, null, null, true, false);
};

function ptOpenUrl(obj)
{
	var gotopGBrowser	= {};
	if (obj.rfr)	// 有来路
	{
		var ios			= Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var referer		= ios.newURI(obj.rfr, null, null);
		//gotopGBrowser	= gBrowser.addTab(obj.url, referer, null, null, true, false);	// loadOneTab
		gotopGBrowser	= gBrowser.loadOneTab(obj.url, {referrerURI: referer, inBackground: true});
	}
	else
		gotopGBrowser	= gBrowser.loadOneTab(obj.url, {inBackground: true});
	
	gotopGBrowser.parentNode.childNodes[gotopGBrowser._tPos].ptTopLevel	= 0;			// 默认为顶层标签页（再打开其中的连接转化为1层）
	gotopGBrowser.parentNode.childNodes[gotopGBrowser._tPos].ptSiteID	= obj.sid;		// 标记识别ID
	ptOnlineTask[obj.sid]	= obj;	// 添加到online task
	applyPopup(obj.url, obj.pop);	// 应用弹窗规则
};

function ptOpenUrlRfr(url, rfr, obj)
{
	var gotopGBrowser	= {};
	var ios			= Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
	if(rfr==null)
		gotopGBrowser	= gBrowser.loadOneTab(url, {inBackground: true});
	else
	{
		var referer		= ios.newURI(rfr, null, null);
		gotopGBrowser	= gBrowser.loadOneTab(url, {referrerURI: referer, inBackground: true});
	}
	gotopGBrowser.parentNode.childNodes[gotopGBrowser._tPos].ptTopLevel	= 0;			// 默认为顶层标签页（再打开其中的连接转化为1层）
	gotopGBrowser.parentNode.childNodes[gotopGBrowser._tPos].ptSiteID	= obj.sid;		// 标记识别ID
	applyPopup(url, obj.pop);	// 应用弹窗规则
};

function getIntPref(prefName)
{
   var result = null;
   var prefs = prefservice.getBranch('');
   if (prefs.getPrefType(prefName) == prefs.PREF_INT) {
	   try { result = prefs.getIntPref(prefName); }catch(e){}
   }
   return(result);
};

function setIntPref(prefName, value)
{
   var prefs = prefservice.getBranch('');
   try { prefs.setIntPref(prefName, value); } catch(e){}
};

function getBoolPref(prefName)
{
   var result = null;
   try { result = prefservice.getBoolPref(prefName); } catch(e){}
   return(result); 
};

function setBoolPref(prefName, value)
{
   var prefs = prefservice.getBranch('');
   try	{	   prefs.setBoolPref(prefName, value);   } catch(e){}
};

function getStrPref(prefName)
{
	var result = null;
	var prefs = prefservice.getBranch('');
	if (prefs.getPrefType(prefName) == prefs.PREF_STRING)
	{
		try { result = prefs.getComplexValue(prefName, Components.interfaces.nsISupportsString).data; }catch(e){}
	}
	return(result);
};

function setStrPref(prefName, value)
{
	var prefs = prefservice.getBranch('');
	var sString = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
	sString.data = value;
	try
	{
		prefs.setComplexValue(prefName, Components.interfaces.nsISupportsString, sString);
	}
	catch(e){}
};

function getTab4LinkedPanel(linkedPanel)	// 由tab的linkedPanel获取tab
{
	for(var j=0; j<gBrowser.mTabContainer.childNodes.length; j++)
	{
		if(gBrowser.mTabContainer.childNodes[j].linkedPanel == linkedPanel)
			return gBrowser.mTabContainer.childNodes[j];
	}
	return null;
};

function fixedWindow(width, height)		// 将sardine窗口固定为软件窗口
{
	document.documentElement.setAttribute('screenX', 50);
	document.documentElement.setAttribute('maxwidth', width);
	document.documentElement.setAttribute('maxheight', height);
	document.documentElement.setAttribute('minwidth', width);
	document.documentElement.setAttribute('minheight', height);
}
function ptSetPath()	// 设置浏览器和dll路径
{
    let dirService	= Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties);
    let profile		= dirService.get("PrfDef", Ci.nsILocalFile);	// https://developer.mozilla.org/en-US/Add-ons/Code_snippets/File_I_O#Getting_files_in_special_directories
    // PrfDef: %installation%/defaults/pref
    //f_logs('dddddddd.txt', var_dump(profile));
    var prfDef	= profile.path.substr(0, profile.path.length - 14);
    ptBrowserPath	= prfDef;
    ptJsDllPath		= ptBrowserPath + ptExtendSuffix + "pt.dll";
    ptJsDataPath	= ptBrowserPath + ptExtendSuffix;
    
    ptJsDll 	= ctypes.open(ptJsDllPath);	// 全局变量
}





function readMemoryLogin()	// 读登录缓冲区
{
	let strArr	= ctypes.char.array(64*1024)();
	var readMemoryLogin	= ptJsDll.declare('readMemoryLogin', ctypes.winapi_abi, ctypes.bool, ctypes.char.array(64*1024));
	var ret	= readMemoryLogin(strArr);
	
	var str = '';
	for(var i=0; i<strArr.length; i++)
	{
		if(strArr[i]==0)
			break;
		str += String.fromCharCode(strArr[i]);
	}
	
	return str;
}

function readMemoryTask()	// 读任务缓冲区
{
	let strArr	= ctypes.char.array(512*1024)();
	var readMemoryTask	= ptJsDll.declare('readMemoryTask', ctypes.winapi_abi, ctypes.bool, ctypes.char.array(512*1024));
	var ret	= readMemoryTask(strArr);
	
	var str = '';
	for(var i=0; i<strArr.length; i++)
	{
		if(strArr[i]==0)
			break;
		str += String.fromCharCode(strArr[i]);
	}
	
	return str;
}

function writeMemoryTask(str)// 写任务区
{
	var writeMemoryTask	= ptJsDll.declare('writeMemoryTask', ctypes.winapi_abi, ctypes.bool, ctypes.char.ptr);
	return writeMemoryTask(str);
}

function cleanMemoryTask()// 清理任务缓冲区
{
	var cleanMemoryTask	= ptJsDll.declare('cleanMemoryTask', ctypes.winapi_abi, ctypes.bool);
	return cleanMemoryTask();
}

function writeMemorySubmit(str)// 输出提交信息
{
	var writeMemorySubmit	= ptJsDll.declare('writeMemorySubmit', ctypes.winapi_abi, ctypes.bool, ctypes.char.ptr);
	return writeMemorySubmit(str);
}

function writeMemoryTalk(str)// 输出对话信息
{
	var writeMemoryTalk	= ptJsDll.declare('writeMemoryTalk', ctypes.winapi_abi, ctypes.bool, ctypes.char.ptr);
	return writeMemoryTalk(str);
}

function isBase64(str)// 输出对话信息
{
	var isBase64	= ptJsDll.declare('isBase64', ctypes.winapi_abi, ctypes.bool, ctypes.char.ptr);
	return isBase64(str);
}

function diskSerial()	// 取磁盘序列号
{
	let strArr	= ctypes.char.array(32)();
	var diskSerial	= ptJsDll.declare('diskSerial', ctypes.winapi_abi, ctypes.bool, ctypes.char.array(32));
	var ret	= diskSerial(strArr);
	
	var str = '';
	for(var i=0; i<strArr.length; i++)
	{
		if(strArr[i]==0)
			break;
		str += String.fromCharCode(strArr[i]);
	}
	
	return str;
}



function read_file(filename)				// 获取文件内容
{
	var file_size	= 0;
	var f = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	f.initWithPath(filename);
	if (!f.exists())
		return '';
	else
	{
		file_size	= f.fileSize;
	}

	var data = "";
	var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	var cstream = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
	fstream.init(f, -1, 0, 0);
	cstream.init(fstream, "UTF-8", 0, 0); // you can use another encoding here if you wish

	let (str = {}) {
	  let read = 0;
	  do { 
	    read = cstream.readString(0xffffffff, str); // read as much as we can and put it in str.value
	    data += str.value;
	  } while (read != 0);
	}
	cstream.close(); // this closes fstream
	return data;
}


// -----------------------------------------------初始化浏览器-------------------------------------------------------------------------------
function initBrowser(debug)
{
	// 扬声器静音
	//window.mozTelephony.muted = true;        // Mutes the phone
	//构造字符串
	setBoolPref(	'accessibility.warn_on_browsewithcaret', false);
	setIntPref(		'accessibility.typeaheadfind.flashBar', 0);						// 为FireFox安装缺失的Flash插件
	setBoolPref(	'app.update.disable_button.showUpdateHistory', false);
	setBoolPref(	'app.update.enabled', false);
	setBoolPref(	'browser.blink_allowed', false);								// 禁止网页闪烁元素
	setIntPref(		'browser.bookmarks.max_backups', 0);
	setBoolPref(	'browser.bookmarks.restore_default_bookmarks', false);
	setIntPref(		'browser.cache.disk.capacity', 0);								// 缓存/脱机文件位置及大小
	setIntPref(		'browser.cache.memory.capacity', 16384);						// 内存缓存
	setBoolPref(	'browser.chrome.favicons', false);
	setBoolPref(	'browser.chrome.site_icons', false);
	setBoolPref(	'browser.ctrlTab.previews', false);
	setBoolPref(	'browser.download.manager.closeWhenDone', true);
	setIntPref(		'browser.download.manager.retention', 0);
	setBoolPref(	'browser.download.manager.scanWhenDone', false);
	setBoolPref(	'browser.download.manager.showWhenStarting', false);
	setBoolPref(	'browser.formfill.enable', false);
	setIntPref(		'browser.history.maxStateObjectSize', 0);						// 历史状态目标最大值
	setBoolPref(	'browser.history.allowPopState', false);
	setBoolPref(	'browser.history.allowPushState', false);
	setBoolPref(	'browser.history.allowReplaceState', false);
	setIntPref(		'browser.history_expire_days', 0);								// 历史记录过期天数
	setIntPref(		'browser.history_expire_days.mirror', 30);
	setIntPref(		'browser.history_expire_days_min', 3);
	setIntPref(		'browser.history_expire_sites', 0);								// 最大保存的站点数量
	setIntPref(		'browser.link.open_newwindow.restriction', 0);
	setIntPref(		'browser.migration.version', 1);
	setBoolPref(	'browser.places.importBookmarksHTML', false);
	setBoolPref(	'browser.places.importDefaults', false);
	setIntPref(		'browser.places.leftPaneFolderId', -1);
	setBoolPref(	'browser.places.migratePostDataAnnotations', false);
	setIntPref(		'browser.places.smartBookmarksVersion', 1);
	setBoolPref(	'browser.places.updateRecentTagsUri', false);
	setIntPref(		'browser.preferences.advanced.selectedTabIndex', 0);
	setBoolPref(	'browser.privatebrowsing.autostart', true);
	setBoolPref(	'browser.rights.3.shown', true);
	setBoolPref(	'browser.safebrowsing.enabled', false);
	setBoolPref(	'browser.safebrowsing.malware.enabled', false);
	setBoolPref(	'browser.search.update', false);								// 不自动升级搜索引擎
	setIntPref(		'browser.sessionhistory.max_entries', 0);						// 地址栏保存的最多行数
	setIntPref(		'browser.sessionhistory.max_total_viewers', 0);					// 页面快进/快退功能中保存的页面总数
	setIntPref(		'browser.sessionstore.interval', 8640000);
	setIntPref(		'browser.sessionstore.max_tabs_undo', 0);
	setIntPref(		'browser.sessionstore.max_windows_undo', 0);
	setBoolPref(	'browser.sessionstore.resume_from_crash', false);
	setBoolPref(	'browser.sessionstore.resume_session_once', true);
	setBoolPref(	'browser.shell.checkDefaultBrowser', false);
	//setStrPref(		'browser.startup.homepage_override.mstone', 'rv:1.9.1.2');
	setIntPref(		'browser.startup.page', 0);
	setBoolPref(	'browser.tabs.animate', false);								// 关闭标签页动画效果
	setBoolPref(	'browser.tabs.autoHide', false);
	setBoolPref(	'browser.tabs.closeWindowWithLastTab', false);				// 关闭最后标签是否关闭浏览器，默认值为true
	setBoolPref(	'browser.tabs.loadInBackground', false);					// false 表示打开新标签页的时候，立即切换到新标签页
	setBoolPref(	'browser.tabs.warnOnClose', false);
	setBoolPref(	'browser.tabs.warnOnCloseOtherTabs', false);
	setBoolPref(	'browser.tabs.warnOnOpen', false);
	setBoolPref(	'browser.taskbar.lists.enabled', false);
	setBoolPref(	'browser.taskbar.lists.frequent.enabled', false);
	setIntPref(		'browser.taskbar.lists.maxListItemCount', 0);
	setBoolPref(	'browser.taskbar.lists.tasks.enabled', true);
	setIntPref(		'browser.urlbar.maxRichResults', 1);
	setBoolPref(	'browser.warnOnQuit', false);
	setBoolPref(	'browser.warnOnRestart', false);
	setBoolPref(	'config.trim_on_minimize', true);
	setBoolPref(	'dom.disable_open_during_load', false);						// 允许弹窗
	setBoolPref(	'dom.disable_window_move_resize', true);
	setBoolPref(	'dom.disable_window_open_feature.close', true);			// 是否防止关闭按钮被禁用
	setBoolPref(	'dom.disable_window_open_feature.directories', true);	// 是否防止收藏栏被禁用
	setBoolPref(	'dom.disable_window_open_feature.location', true);	
	setBoolPref(	'dom.disable_window_open_feature.menubar', true);
	setBoolPref(	'dom.disable_window_open_feature.minimizable', true);
	setBoolPref(	'dom.disable_window_open_feature.personalbar', true);
	setBoolPref(	'dom.disable_window_open_feature.resizable', true);
	setBoolPref(	'dom.disable_window_open_feature.scrollbars', true);
	setBoolPref(	'dom.disable_window_open_feature.status', true);
	setBoolPref(	'dom.disable_window_open_feature.titlebar', true);
	setBoolPref(	'dom.disable_window_open_feature.toolbar', true);
	setBoolPref(	'dom.event.contextmenu.enabled', false);
	setIntPref(		'dom.max_script_run_time', 2);
	setIntPref(		'dom.popup_maximum', 2);					// 一个非点击事件(non-click event)可同时弹出的窗口数
	setIntPref(		'extensions.autoDisableScopes', 0);			// 设置让自动安装扩展
	setIntPref(		'extensions.enabledScopes', 15);			// 设置让自动安装扩展
	setBoolPref(	'extensions.dss.enabled', false);			// 不允许动态切换主题
	//setStrPref(		'extensions.enabledItems', 'root@gotop.org:1.8.0');
	//setStrPref(		'extensions.lastAppVersion', ''sysBrsplusEdition'');
	setBoolPref(	'extensions.update.enabled', false);
	setBoolPref(	'extensions.update.notifyUser', false);
	setBoolPref(	'general.autoScroll', false);
	setStrPref(		'general.useragent.locale', 'zh-CN');
	//setStrPref(		'general.useragent.override', ''+ myUA +'');
	setBoolPref(	'general.warnOnAboutConfig', false);
	setIntPref(		'idle.lastDailyNotification', 1250067624);
	setStrPref(		'image.animation_mode', 'none');									// 不播放动画图片
	setStrPref(		'intl.charsetmenu.browser.cache', 'GB2312, GBK, UFT-8');
	setIntPref(		'layout.spellcheckDefault', 0);
	setBoolPref(	'media.autoplay.enabled',	false);
	setBoolPref(	'network.cookie.prefsMigrated', true);
	setIntPref(		'network.http.max-connections', 32768);								// http最大连接数,默认24
	setIntPref(		'network.http.max-connections-per-server', 16);						// 单个服务器能够同时打开的连接数,默认为8
	setIntPref(		'network.http.max-persistent-connections-per-server', 6);			// 单个服务器上同时有多少连接处于活动状态。默认值为2
	setBoolPref(	'network.http.pipelining', true);
	setIntPref(		'network.http.pipelining.maxrequests', 32);							// 使用HTTP Pipelining特性时发送的最大连接请求。默认值为4，最大值为8
	setBoolPref(	'network.http.proxy.pipelining', true);
	setBoolPref(	'network.prefetch-next', false);
	setBoolPref(	'network.protocol-handler.external.mailto', false);					// 屏蔽 mailto:
	setBoolPref(	'network.protocol-handler.warn-external-default', false);
	setIntPref(		'network.proxy.type', 0);
	setBoolPref(	'nglayout.enable_drag_images', false);								// 禁止按住图片并拖动
	setIntPref(		'permissions.default.image', 1);									// 2不自动载入图片，1自动载入
	setBoolPref(	'plugin.default_plugin_disabled', false);
	setBoolPref(	'privacy.clearOnShutdown.offlineApps', true);
	setBoolPref(	'privacy.clearOnShutdown.passwords', true);
	setBoolPref(	'privacy.cpd.downloads', false);	//下载记录
	setBoolPref(	'privacy.cpd.formdata', false);		//表单
	setBoolPref(	'privacy.cpd.offlineApps', false);
	setBoolPref(	'privacy.cpd.passwords', false);
	setBoolPref(	'privacy.item.cookies', true);
	setBoolPref(	'privacy.item.offlineApps', true);
	setBoolPref(	'privacy.item.passwords', true);
	setIntPref(		'privacy.popups.disable_from_plugins', 1);							// 0 = 允许插件弹窗 , 1 = 允许插件弹窗, 但数量不超过 dom.popup_maximum 的值 , 2 = 禁止插件弹窗 , 3 = 即使网址在允许名单中，也禁止插件弹窗
	setIntPref(		'privacy.popups.policy', 1);										// 非请求式弹窗处理策略？1 接受；2 拦截
	setBoolPref(	'privacy.popups.showBrowserMessage', false);						// 显示拦截到弹窗的消息栏
	setBoolPref(	'privacy.sanitize.didShutdownSanitize', true);
	setBoolPref(	'privacy.sanitize.migrateFx3Prefs', true);
	setBoolPref(	'privacy.sanitize.promptOnSanitize', false);
	setBoolPref(	'privacy.sanitize.sanitizeOnShutdown', true);
	setBoolPref(	'roaming.showInitialWarning', false);
	setStrPref(		'security.default_personal_cert', 'Select Automatically');
	setBoolPref(	'security.enable_java', false);
	setBoolPref(	'security.enable_ssl3', true);
	setBoolPref(	'security.enable_tls', true);
	setBoolPref(	'security.warn_entering_weak', false);
	setBoolPref(	'security.warn_entering_weak.show_once', false);
	setBoolPref(	'security.warn_viewing_mixed', false);
	setBoolPref(	'security.warn_viewing_mixed.show_once', false);
	setBoolPref(	'signon.rememberSignons', false);
	setStrPref(		'startup.homepage_override_url', 'about:blank');
	setBoolPref(	'xpinstall.whitelist.required', false);
/*	*/
	if(debug==true)
	{
		setBoolPref(	'browser.dom.window.dump.enabled', true);		// 允许使用 dump() 语句向标准控制台输出信息
		setBoolPref(	'javascript.options.showInConsole', true);		// 把 JavaScript 的出错信息显示在错误控制台
		setBoolPref(	'javascript.options.strict', true);				// 在错误控制台中启用严格的 JavaScript 警告信息
		setBoolPref(	'nglayout.debug.disable_xul_cache', true);		// 禁用 XUL 缓存，使得对窗口和对话框的修改不需要重新加载 XUL 文件
		setBoolPref(	'nglayout.debug.disable_xul_fastload', true);
	}
	else
	{
		setBoolPref(	'browser.dom.window.dump.enabled', false);
		setBoolPref(	'javascript.options.showInConsole', false);
		setBoolPref(	'javascript.options.strict', false);
		setBoolPref(	'nglayout.debug.disable_xul_cache', false);
		setBoolPref(	'nglayout.debug.disable_xul_fastload', false);
	}
};

