// 操作文档对象
function operateDocument(tab, doc)
{
	var url		= doc.URL;	// location.href;
	var rfr		= doc.referrer;
	if(url=='about:blank' || url=='about:home')	return;

	var glb		= ptOnlineTask[tab.ptSiteID];
	if(glb.type==0)	// 刷流量
	{
		//-------------------------------------------------------------------------------枚举iframe
		var frame	= Array('IFRAME', 'FRAME');
		for(var j=0; j<frame.length; j++)
		{
			var fm	= doc.getElementsByTagName( frame[j] );
			for(var i=0; i<fm.length; i++)
				operateDocument(tab, fm[i].contentWindow.document);
		}

		var lingerMax	= parseInt(glb.lingerMax);
		var lingerMin	= parseInt(glb.lingerMin);
		var linger		= getRandom(lingerMin, lingerMax);
		
		var order	= makeTimeSequence( linger );			// 时序
		//f_logs('timeSequence.txt', var_dump_ergodic(order));
		for(var j=0; j<order.length; j++)
		{
			var type		= 1;
			if		(j==0)	type = 0;			// 第一次鼠标事件 && 顶层窗口  		=> 移动/可能要点击body
			if		(j==(order.length-1))		// 最后一步 (type = 2点击)
			{
				if		(tab.ptTopLevel==0 && Math.random()<(glb.click / 100))	// 1次点显比
					type = 2;
				else if	(tab.ptTopLevel==1 && Math.random()<(glb.click2 / 100))	// 2次点显比
					type = 2;
			}
			mouseTimeutEvent(tab, type, order[j]);
		}
	}
};


function OnDOMContentLoaded(aEvent)
{
	if (!(aEvent.originalTarget instanceof HTMLDocument) )
		return;
	
	
	
	// 检查是否继承了ptSiteID对象，如果没有继承则比对referer，找到最相近的为对象复制过来
	for(var i=0; i<gBrowser.mTabContainer.childNodes.length; i++)
	{
		//f_logs('dsfa.txt', var_dump(gBrowser.mTabContainer.childNodes[i].linkedBrowser.contentDocument));
		if((!gBrowser.mTabContainer.childNodes[i].ptSiteID)&& gBrowser.mTabContainer.childNodes[i].linkedBrowser.contentDocument.referrer)
		{
			var rfr	= gBrowser.mTabContainer.childNodes[i].linkedBrowser.contentDocument.referrer;
			//var str	= "\r\n" + rfr + "\r\n\r\n";
			// 来路比对其它网址
			for(var j=0; j<gBrowser.mTabContainer.childNodes.length; j++)
			{
				if(gBrowser.mTabContainer.childNodes[j].ptSiteID)
				{
					var url	= gBrowser.mTabContainer.childNodes[j].linkedBrowser.contentDocument.URL;
					//str += url + "||||||||||||||||||||||||||||||||||||||||||||\r\n" + var_dump(gBrowser.mTabContainer.childNodes[j].ptSiteID) + "\r\n";
					// 比对网址
					if(rfr==url)
					{
						gBrowser.mTabContainer.childNodes[i].ptSiteID	= gBrowser.mTabContainer.childNodes[j].ptSiteID;
						gBrowser.mTabContainer.childNodes[i].ptTopLevel++;
					}
				}
			}
			//f_logs('gggg.txt', str);
		}
	}
	
	var doc	= aEvent.originalTarget;
	
	//屏蔽onerror
	var images	= doc.getElementsByTagName('img');
	for(var i=0; i<images.length; i++)
	{
		images[i].onerror = null;
	}

	// 屏蔽 onbeforeunload
	var this_body	= doc.getElementsByTagName('body')[0];
	if(this_body==null)
		return ;
	var this_script	= doc.createElement('script');
	this_script.setAttribute('type','text/javascript');
	this_script.innerHTML = "window.onbeforeunload = function() {}";
	this_body.appendChild(this_script);
};

var cleanSubmitTask	= setInterval(function submitTask()
{
	if(ptPreSubmit.length>0)
	{
		var put	= {	'ver'			: ptVer,
					'pid'			: ptPID,
					'language'		: ptLanguage,
					'time'			: Date.now(),
					'userid'		: ptUserID,
					'task'			: ptTaskCount,
					'page'			: ptPageCount,
					'mark'			: ptPreSubmit
			};
		ptPreSubmit	= [];
		var submitData = window.btoa(JSON.stringify(put));
		writeMemorySubmit(submitData);
	}
}, 5*60*1000);

function coreProcess()	// 核心管理进程
{
	
	ptCustomTitle.init();							// 自定义app标题栏
	gBrowser.addEventListener('DOMContentLoaded', OnDOMContentLoaded, false);	// DOMContentLoaded
	
	//prompts.alert(null, 'dddddddddd', 'dddddddddddddddddddxxxxxxxxxxx');

	var taskTimeOut	= 1199;	// 循环时间
	var cleanTm	= setInterval(function ()
	{
		// ---------------------------------------------------------------------------------------------关闭列表
		for(var j=0; j<gBrowser.mTabContainer.childNodes.length; j++)
		{
			var tab		= gBrowser.mTabContainer.childNodes[j];
			//if(!tab)	continue;
			if(!tab.ptCTime)
				tab.ptCTime	= timeStamp();
			// 关闭严重超时的
			if((timeStamp() - tab.ptCTime)>180)
			{
				delTab(tab);
				return;
			}
			
			
			// 时间比对
			if(tab.ptSiteID && ptOnlineTask[tab.ptSiteID] && tab.linkedBrowser.contentDocument.readyState=='complete')
			{
				taskStatus('载入成功，进入循环检测');
				
				// 创建页面的等待时间
				if(!tab.ptlingerTime)
				{
					var lingerMax		= parseInt(ptOnlineTask[tab.ptSiteID].lingerMax);
					var lingerMin		= parseInt(ptOnlineTask[tab.ptSiteID].lingerMin);
					tab.ptlingerTime	= Math.round(getRandom(lingerMin, lingerMax));
				}
				
				
				// 获取事件（模拟点击）派发标示，并发送点击派发任务
				var type = ptOnlineTask[tab.ptSiteID].type;
				if(!tab.ptVirtualDispatch)
				{
					tab.ptVirtualDispatch	= true;
					if(type==0)
						operateDocument(tab, tab.linkedBrowser.contentDocument);
					else
					{
						tab.ptlingerTime	= 180;	// 搜索引擎的话，给180秒
						operateSearchEngine(tab);
					}
				}
					
				
				var timeDiff	= timeStamp() - tab.ptCTime;
				taskStatus('时间差：' + timeDiff + '，等待时间：' + tab.ptlingerTime);
				//f_logs('__time.txt', Date.now()+ '____' +tab.ptCTime + '____' + lingerMax + '____' + lingerMin + '___' + linger);
				if(timeDiff>tab.ptlingerTime && type==0)// 可以关闭
				{
					if(ptOnlineTask[tab.ptSiteID].pv>1)
					{
						var url			= tab.linkedBrowser.contentDocument.URL;
						taskStatus(url);
						if(ptOnlineTask[tab.ptSiteID].pvMethod==0)	// PV方式为智能
						{
							var aClick	= [];
							var domain	= getDomain(url);
		
							// 找出可用的链接
							//var astr	= "\r\n==========================================================\r\n" + url + "\r\n\r\n";
							var urls	= tab.linkedBrowser.contentDocument.getElementsByTagName('a');
							for (var k=0; k<urls.length; k++)
							{
								//astr += urls[k].href + "\r\n";							
								var isOk	= true;
								// 屏蔽非法后缀
								for(var m=0; m<ptIllicitSuffix.length; m++)
								{
									if(urls[k].href.toLowerCase().indexOf(ptIllicitSuffix[m])>0)
									{
										isOk	= false;
										break;
									}
								}
								// 选中是本站根域名的
								if(isOk==true && getDomain( urls[k].href )==domain)
									aClick.push(k);
							}
							//f_logs('__urls.txt', astr);
								
							// 在本标签页产生PV
							updateTaskStatus(0, 1);
							ptOnlineTask[tab.ptSiteID].pv--;
							if(aClick.length>0)
							{	
								var idx	= Math.round(getRandom(0, aClick.length-1));
								ptOpenUrlRfr(urls[aClick[idx]].href, url, ptOnlineTask[tab.ptSiteID]);

								var innerHTML_Length	= tab.linkedBrowser.contentDocument.getElementsByTagName('html')[0].innerHTML.length;
								var childElementCount	= tab.linkedBrowser.contentDocument.getElementsByTagName('html')[0].getElementsByTagName('*').length;
								ptAddPreSubmit(tab.ptSiteID, url, innerHTML_Length, childElementCount);
								taskStatus('标签页PV：' + urls[aClick[idx]].href);
								setTimeout(function(){
									delTab(tab);
									}, 900);
								return;
							}
						}
						else// PV单页重复
						{
							updateTaskStatus(0, 1);
							ptOnlineTask[tab.ptSiteID].pv--;
							if(ptOnlineTask[tab.ptSiteID].rfr)
								ptOpenUrlRfr(ptOnlineTask[tab.ptSiteID].url, ptOnlineTask[tab.ptSiteID].rfr, ptOnlineTask[tab.ptSiteID]);
							else
								ptOpenUrlRfr(ptOnlineTask[tab.ptSiteID].url, null, ptOnlineTask[tab.ptSiteID]);
							var innerHTML_Length	= tab.linkedBrowser.contentDocument.getElementsByTagName('html')[0].innerHTML.length;
							var childElementCount	= tab.linkedBrowser.contentDocument.getElementsByTagName('html')[0].getElementsByTagName('*').length;
							ptAddPreSubmit(tab.ptSiteID, url, innerHTML_Length, childElementCount);
								
							taskStatus('重复页PV：' + ptOnlineTask[tab.ptSiteID].url);
							setTimeout(function(){
								delTab(tab);
								}, 900);
							
							return;
						}
					}
					else
					{
						// 删除ptOnlineTask中保存的
						for(i in ptOnlineTask)
						{
							if(ptOnlineTask[i].sid== tab.ptSiteID)
							{
								ptOnlineTask.splice(i, 1);
								break;
							}
						}
						delTab(tab);
						return;
					}
				}
			}
		}
	}, taskTimeOut);
	/* */
};


// 打开标签页
setInterval(function ()
{
	// 动态读登录交换区，获得参数
	if(ptLoginSucceed==true)
	{
		var body	= readMemoryLogin();
		if(body.length>0)
		{
			var json	= JSON.parse(body);
			if(json!=null && json!=undefined)
			{
				if(json.todo=='toBrowser')
				{
					if(json.browserSpeed==1)
						ptMaxTabs	= 7;
					else if(json.browserSpeed==2)
						ptMaxTabs	= 9;
					else
						ptMaxTabs	= 5;
					
					ptUserID	= json.userid;
					ptPID		= json.pid;
					ptLanguage	= json.language;
					ptVer		= json.ver;
					commStatus('pid:'+ptPID + ', lan:'+ptLanguage + ', ver:'+ ptVer);
				}
			}
		}
		
		
		if(ptJsonTask.length>0 && gBrowser.mTabContainer.childNodes.length<ptMaxTabs)
		{
			
			var obj	= ptJsonTask.shift();		// 移除最前一个元素并返回该元素值，数组中元素自动前移
			ptOpenUrl(obj);
			updateTaskStatus(1, 1);				// 增加显示的任务数 / 页面数
			commStatus('打开新任务：' + obj.url + ', PV: '+ obj.pv);
		}
		else
			updateTaskStatus(0, 0);	// 实质上是发送时间标志	
	}
	
}, 5000);



window.addEventListener('load', coreProcess, false);	// 浏览器打开时运行








