var ptTimeOut	= 30;			// 页面的最大超时时间（真实访问独有）
var	ptTGUrl		= '';			// 被推广的网址（真实访问独有）
var ptTGTask	= [];			// 浏览的网站列表（真实访问独有）
var ptTGSubmit	= [];			// 执行完任务以后，向服务器发送的参数（多维数组）

var ptLinkColor	= '#4876FF';	// 鼠标在链接上的颜色
var ptLinkHover	= '#F00';		// 鼠标移开后的颜色
var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

// 在菜单栏的后边新建一个标签，用来调试输出
var newNode = document.createElement("label");
newNode.id	= 'ptCommonMsg';
newNode.style.color	= '#00F';
document.getElementById('toolbar-menubar').appendChild(newNode );
document.getElementById('ptCommonMsg').textContent	= 'Msstbc out status message box!';

// 用来输出任务信息
var newTaskNode = document.createElement("label");
newTaskNode.id	= 'ptTaskMsg';
newTaskNode.style.color	= '#0F0';
document.getElementById('toolbar-menubar').appendChild(newTaskNode );
document.getElementById('ptTaskMsg').textContent	= 'Task message box!';


ptSetPath();					// 设置浏览器和dll路径
ptDiskSerial = diskSerial();	// 取磁盘序列号

// 修改浏览器默认的标题栏
var ptCustomTitle = {
	init: function()
	{
		var tabbrowser = document.getElementById("content");
		tabbrowser.updateTitlebar = ptCustomTitle.updateTitlebar;
		document.getElementById("content").addEventListener("DOMTitleChanged", ptCustomTitle.updateTitlebar, false);
	},

	updateTitlebar: function ()
	{
		var tabbrowser = document.getElementById("content");
		tabbrowser.ownerDocument.title = ptSysName;
	}
};




// 每几秒钟打开一个网站
var iID = setInterval(makeTask, 2500);
function makeTask()
{
	var body	= readMemoryLogin();
	if(body.length>0)
	{
		var json	= JSON.parse(body);
		if(json!=null && json!=undefined)
		{
			if(json.todo=='toBrowser')
			{
				if(json.browserSpeed==1)
					ptMaxTabs	= 6;
				else if(json.browserSpeed==2)
					ptMaxTabs	= 8;
				else
					ptMaxTabs	= 4;
				
				ptUserID	= json.userid;
				ptPID		= json.pid;
				ptLanguage	= json.language;
				ptVer		= json.ver;
				commStatus('pid:'+ptPID + ', lan:'+ptLanguage + ', ver:'+ ptVer +', userid:' + ptUserID + ', diskSerial:'+ptDiskSerial);
			}
		}
	}

	
	if(ptTGTask.length>0 && gBrowser.mTabContainer.childNodes.length<ptMaxTabs)
	{
		var url = ptTGTask.shift();
		ptTGOpenUrl(url, ptTGUrl);
		updateTaskStatus(1, 1);				// 增加显示的任务数 / 页面数
	}
	else
		updateTaskStatus(0, 0);	// 实质上是发送时间标志
}


//登录并获取浏览器Agent
if(ptLoginSucceed==false)
{
	var base64	= readMemoryLogin();
	if(base64.length>0 && isBase64(base64)==true)
	{
		var body	= window.atob(base64);
		var json	= JSON.parse(body);	// JSON.parse为火狐内部函数，无错误机制，故舍之
		if(json!=null && json!=undefined)
		{
			if(json.isOk=='true')
			{
				ptUserID	= json.userid;
				ptLoginSucceed	= true;
				commStatus('login succeed!');
			}
		}
	}
}


//获取任务
var ptGetTaskOut	= 5500;
var ptPin			= '';
var ptGetTask		= setInterval(function ()
{
	if(ptTGTask.length==0)
	{
		var base64	= readMemoryTask();
		if(base64.length>0 && isBase64(base64)==true)	// 任务为base64，通讯则不是
		{
			var json = JSON.parse(window.atob(base64));
			if(json!==null && json!==undefined)
			{
				commStatus('Get task succeed!' + ' protocol=' + json.protocol);
				if(json.protocol=='20150805')	// 协议版本
				{
					if(ptPin!=json.pin)
					{
						ptAgent		= json.agent;
						ptAcceptLan	= json.agentLan;
						ptTimeOut	= json.timeout;
						ptTGUrl		= json.url;
						ptTGTask	= json.domains;
						ptPin		= json.pin;
					}
					else
						cleanMemoryTask();
					return;
				}
			}
		}
	}
}, ptGetTaskOut);



initBrowser(true);										// 初始化浏览器



